


// we have no data. go get some.
if ((isNil "_results") && (isNil "drawData")) exitWith {
    [] execVM "gatherData.sqf";
};
// _results has new data for us.
if (!(isNil "_results") && {_results isNotEqualTo []}) then {
    drawData = _results;
};


if !(isNil "graph_drawEH") then {
	(findDisplay 12 displayCtrl 51) ctrlRemoveEventHandler ["Draw", graph_drawEH];
	graph_drawEH = nil;
};


graph_drawEH = (findDisplay 12 displayCtrl 51) ctrlAddEventHandler ["Draw", {

    private _uiPos = [3000,2000,0];
    private _uiWidth = 4000;
    private _uiHeight = 2000;

	(_this # 0) drawRectangle [
		_uiPos,
		_uiWidth / 2,
		_uiHeight / 2,
		0,
		[1,1,1,1],
		"#(rgb,8,8,3)color(0,0,0,0.7)"
	];

    for "_i" from -OFFSET to OFFSET step OFFSET_STEP do {
        (_this # 0) drawIcon [
            "#(rgb,1,1,1)color(1,1,1,1)",
            [0,0,1,1],
            [
                ((_uiPos#0) - (_uiWidth/2)) + (linearConversion [-OFFSET, OFFSET, _i, 0, _uiWidth, true]),
                _uiPos#1 - (_uiHeight/2) - 100,
                0
            ],
            0,
            0,
            0,
            ["",str _i] select ((_i % 5) isEqualTo 0),
            1,
            -1,
            "TahomaB",
            "center"
        ];
    };

    (_this # 0) drawIcon [
        "#(rgb,1,1,1)color(1,1,1,1)",
        [0,0,1,1],
        [
            _uiPos#0,
            ((_uiPos#1) - (_uiHeight/2)) - 200,
            0
        ],
        0,
        0,
        0,
        "Explosive Offset Distance from model center on X axis",
        1,
        -1,
        "TahomaB",
        "center"
    ];

    // Damage numbers
    for "_i" from 0 to 1 step 0.25 do {
        (_this # 0) drawIcon [
            "#(rgb,1,1,1)color(1,1,1,1)",
            [0,0,1,1],
            [
                _uiPos#0 - (_uiWidth/2) - 100,
                ((_uiPos#1) - (_uiHeight/2)) + (_uiHeight * _i),
                0
            ],
            0,
            0,
            0,
            str _i,
            1,
            -1,
            "TahomaB",
            "left"
        ];
    };

    (_this # 0) drawIcon [
        "#(rgb,1,1,1)color(1,1,1,1)",
        [0,0,1,1],
        [
            _uiPos#0 - (_uiWidth/2) - 400,
            ((_uiPos#1) + (_uiHeight/2)) + 100,
            0
        ],
        0,
        0,
        0,
        "return of `damage _building` (0-1)",
        1,
        -1,
        "TahomaB",
        "center"
    ];


    private _colours = [
        [1,0,0,1],
        [0,1,0,1],
        [0,0,1,1]
    ];



    {

        private _colourSelect = _forEachIndex;
        (_this # 0) drawIcon [
            "#(rgb,1,1,1)color(1,1,1,1)",
            _colours # _colourSelect,
            [
                _uiPos#0 - (_uiWidth/2) - 100,
                ((_uiPos#1) - (_uiHeight/2)) - 200 - (100 * _colourSelect),
                0
            ],
            0,
            0,
            0,
            _x # 0,
            1,
            -1,
            "TahomaB",
            "left"
        ];

        private _damageData = _x # 1;
        {
            _x params ["_offset","_damage"];
            (_this # 0) drawIcon [
                "\A3\ui_f\data\map\markers\military\dot_CA.paa",
                _colours # _colourSelect,
                [
                    ((_uiPos#0) - (_uiWidth/2)) + (linearConversion [-OFFSET, OFFSET, _offset, 0, _uiWidth, true]),
                    ((_uiPos#1) - (_uiHeight/2)) + (_uiHeight * _damage),
                    0
                ],
                10,
                10,
                0,
                "",
                1,
                -1,
                "TahomaB",
                "center"
            ];



            private _nextDataPoint = _damageData # (_forEachIndex + 1);
            if !(isNil "_nextDataPoint") then {
                _nextDataPoint params ["_nextoffset", "_nextdamage"];
                (_this # 0) drawLine [
                    [
                        ((_uiPos#0) - (_uiWidth/2)) + (linearConversion [-OFFSET, OFFSET, _offset, 0, _uiWidth, true]),
                        ((_uiPos#1) - (_uiHeight/2)) + (_uiHeight * _damage),
                        0
                    ], [
                        ((_uiPos#0) - (_uiWidth/2)) + (linearConversion [-OFFSET, OFFSET, _nextoffset, 0, _uiWidth, true]),
                        ((_uiPos#1) - (_uiHeight/2)) + (_uiHeight * _nextdamage),
                        0
                    ],
                    _colours # _colourSelect
                ];
            };

        } forEach _damageData;
    } forEach drawData;
}];
