

player allowDamage false;
private _results = [];

// Building to spawn
#define STRUCTURE_CLASS "Land_i_Barracks_V1_F"
// height above the ground building will be placed.
#define BUILDING_HEIGHT 3
// max distance explosives will be placed from 0,0 in meters.
#define OFFSET 35
// Steps between offset ints
#define OFFSET_STEP 0.5
// Height above 0,0 the explosive will be placed. relative to model
#define EXPLOSIVE_HEIGHT 0.55



// Gather data.
private _actionpos = [64, 64, 3];
{
    if !(isPlayer _x) then {
        deleteVehicle _x;
    };
} forEach nearestObjects [_actionpos, [], 5];

private _pos = [64, 64, BUILDING_HEIGHT];
private _posPlr = [32, 32, 0];
player setPosATL _posPlr;
player setDir (_posPlr getDir _pos);
{
    private _data = [];
    for "_i" from -OFFSET to OFFSET step OFFSET_STEP do {
        private _building = STRUCTURE_CLASS createVehicle [0, 0, 0];
        _building setPosATL _pos;
        private _explosive = _x createVehicle [0, 0, 0];
        _explosive setPosATL (_pos vectorAdd [_i, 0, EXPLOSIVE_HEIGHT]);

        _explosive setDamage 1;

        private _timeout = time + 0.1;
        waitUntil {
            sleep diag_deltaTime;
            hintSilent format["GATHERING DATA\n%3\n%1 || %2", (_timeout - time) toFixed 2, _i, _x];
            (damage _building isNotEqualTo 0) ||
            (time > _timeout);
        };

        _data pushBack [_i, damage _building];

        if ((damage _building) isEqualTo 1) then {
            {
                if !(isPlayer _x) then {
                    deleteVehicle _x;
                };
            } forEach nearestObjects [_pos, [], 3];
        };

        deleteVehicle _building;
        sleep diag_deltaTime;
    };
    _results pushBack [_x, _data];
} forEach ["DemoCharge_Remote_Ammo","SatchelCharge_Remote_Ammo"];

// copyToClipboard str _results;

// draw graph
// [_results] execVM "drawGraph.sqf";
#include "drawGraph.sqf";

openMap true;
